//
//  BTree.cpp
//  BTree
//
//  Created by 葉朝鈞 on 2019/2/16.
//  Copyright © 2019 TalentEndless. All rights reserved.
//

#include <iostream>
#include "BTree.hpp"

using namespace std;

BTree::BTree(int a) {
    root = new BTreeNode(a, true);
    this->a = a;
}

int BTree::traverse() {
    return root->traverse();
}

BTreeNode* BTree::lookup(int k) {
    return root->lookup(k);
}

void BTree::insert(int k) {
    if (root->n == (a << 1) - 1) {
        BTreeNode *x = new BTreeNode(a, false);
        x->splitChild(0, root);
        root = x;
    }
    root->insert(k);
}

void BTree::remove(int k) {
    root->remove(k);
    if (root->n == 0 && !root->leaf) {
        BTreeNode *x = root;
        root = root->childs[0];
        delete x;
    }
}
