//
//  BPlusTree.cpp
//  B+Tree
//
//  Created by 葉朝鈞 on 2021/3/30.
//  Copyright © 2021 葉朝鈞. All rights reserved.
//

#include "BPlusTree.hpp"
#include "BPlusTreeNode.hpp"

using namespace std;


BPlusTree::BPlusTree(int a) {
    root = new BPlusTreeNode(a, true);
    this->a = a;
}

void BPlusTree::traverse() {
    root->traverse();
}

BPlusTreeNode* BPlusTree::lookup(int k) {
    return root->lookup(k);
}

void BPlusTree::insert(int k) {
    if (root->n == (a << 1) - 1) {
        BPlusTreeNode *x = new BPlusTreeNode(a, false);
        x->splitChild(0, root);
        root = x;
    }
    root->insert(k);
}

void BPlusTree::remove(int k) {
    root->remove(k);
    if (root->n == 0 && !root->leaf) {
        BPlusTreeNode *x = root;
        root = root->childs[0];
        delete x;
    }
}
