//
//  main.cpp
//  B+Tree
//
//  Created by 葉朝鈞 on 2021/3/30.
//  Copyright © 2021 葉朝鈞. All rights reserved.
//

#include <iostream>
#include "BPlusTree.hpp"
#define MAXN 1000005
using namespace std;

int main(int argc, const char * argv[]) {

    srand(11);
    
    BPlusTree tree = BPlusTree(3);
    
    int arr[MAXN] = { 0 };
    
    for (int i = 0; i < MAXN; i++)
        arr[i] = i + 1;
    
    for (int i = 0; i < MAXN; i++)
        swap(arr[i], arr[rand() % MAXN]);
    
    for (int i = 14; i > 0; i--)
        tree.insert(i);

    int p = 0, q = 0;
    while (q != MAXN) {
        if (p < MAXN) {
            cout << "=> I: " << arr[p] << endl;
            tree.insert(arr[p++]);
        }
        if (q < MAXN && (p == MAXN || (rand() & 1) == 0)) {
            cout << "=> D: " << arr[q] << endl;
            tree.remove(arr[q++]);
        }
    }

    tree.traverse();
    
    return 0;
}
